%%%%%INTRODUCCIN DE DATOS %%%%%
clc
long = [4 3 5.2 5.2 4 3 2.6 2.3 2.5];
ang = [90 90 0 0 90 90 0 0 90];
E = 21e6*[1 1 1 1 1 1 1 1 1];
A4040 = 0.4*0.4;
A3030 = 0.30*0.3;
A2050 = 0.2*0.50;
area = [A4040 A3030 A2050 A2050 A4040 A3030 ...
        A2050 A2050 A4040];
I4040 = 0.4*0.4^3/12;
I3030 = 0.3*0.3^3/12;
I2050 = 0.2*0.5^3/12;

inercia = [I4040 I3030 I2050 I2050 I4040 I3030 ...
        I2050 I2050 I4040];
        
conexion = [1 1 2;
            2 2 3;
            3 2 5;
            4 3 6;
            5 4 5;
            6 5 6;
            7 5 7;
            8 7 9;
            9 8 9];
%%%%%MATRIZ DE RIGIDEZ DE CADA ELEMENTO %%%%%        
for i=1:9
  EAL = E(i)*area(i)/long(i);
  EI12 = 12*E(i)*inercia(i)/long(i)^3;
  EI6 = 6*E(i)*inercia(i)/long(i)^2;
  EI4 = 4*E(i)*inercia(i)/long(i);
  EI2 = 2*E(i)*inercia(i)/long(i);

  Klocal=[EAL 0 0 -EAL 0 0; 
          0 EI12 EI6 0 -EI12 EI6;
          0 EI6 EI4 0 -EI6 EI2;
          -EAL 0 0 EAL 0 0;
          0 -EI12 -EI6 0 EI12 -EI6;
          0 EI6 EI2 0 -EI6 EI4];

  cs = cosd(ang(i));
  sn = sind(ang(i));
  B = [cs sn 0 0 0 0;
       -sn cs 0 0 0 0;
       0 0 1 0 0 0;
       0 0 0 cs sn 0;
       0 0 0 -sn cs 0;
       0 0 0 0 0 1];
  Kelem(:,:,i) = B'*Klocal*B; 
endfor
%%%%% CALCULO DE GRADOS DE LIBERTAD %%%%%
for i=1:9
  deNudo = conexion(i,2);
  aNudo = conexion(i,3);
  GDL(i,:) = [deNudo*3-2 deNudo*3-1 deNudo*3 ...
         aNudo*3-2 aNudo*3-1 aNudo*3];
endfor

%%% Ensamblar la matriz de rigidez Global %%%
Kglobal = zeros(27,27);

for i=1:9
GDLelem = GDL(i,:);
Kglobal(GDLelem,GDLelem) = Kelem(:,:,i)+Kglobal(GDLelem,GDLelem);
endfor
Kglobal


